Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_read_status.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_read_status.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_read_status.cpp	(revision 123)
@@ -26,11 +26,5 @@
     log_function(Register_unit_Glue,FUNCTION,_name.c_str());
 
-//     if (not PORT_READ(in_NRESET))
-//       {
-// 	for (uint32_t j=0; j<_param->_nb_spr_read; j++)
-// 	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
-// 	    PORT_WRITE(out_SPR_READ_STATUS_VAL       [i][j], 0);
-//       }
-//     else
+    if (PORT_READ(in_NRESET))
       {
 	for (uint32_t j=0; j<_param->_nb_spr_read; j++)
@@ -48,4 +42,10 @@
 	  }
       }
+    else
+      {
+	for (uint32_t j=0; j<_param->_nb_spr_read; j++)
+	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	    PORT_WRITE(out_SPR_READ_STATUS_VAL       [i][j], 0);
+      }
 
     log_end(Register_unit_Glue,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_registerfile.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_registerfile.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_registerfile.cpp	(revision 123)
@@ -26,11 +26,5 @@
     log_function(Register_unit_Glue,FUNCTION,_name.c_str());
 
-//     if (not PORT_READ(in_NRESET))
-//       {
-// 	for (uint32_t j=0; j<_param->_nb_spr_write; j++)
-// 	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
-// 	    PORT_WRITE(out_SPR_WRITE_REGISTERFILE_VAL [i][j], 0);
-//       }
-//     else
+    if (PORT_READ(in_NRESET))
       {
 	for (uint32_t j=0; j<_param->_nb_spr_write; j++)
@@ -48,4 +42,10 @@
 	  }
       }
+    else
+      {
+	for (uint32_t j=0; j<_param->_nb_spr_write; j++)
+	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	    PORT_WRITE(out_SPR_WRITE_REGISTERFILE_VAL [i][j], 0);
+      }
 
     log_end(Register_unit_Glue,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_write.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_write.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_write.cpp	(revision 123)
@@ -26,11 +26,5 @@
     log_function(Register_unit_Glue,FUNCTION,_name.c_str());
 
-//     if (not PORT_READ(in_NRESET))
-//       {
-// 	for (uint32_t j=0; j<_param->_nb_spr_write; j++)
-// 	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
-// 	    PORT_WRITE(out_SPR_WRITE_ACK [j], 0);
-//       }
-//     else
+    if (PORT_READ(in_NRESET))
       {
 	for (uint32_t j=0; j<_param->_nb_spr_write; j++)
@@ -43,4 +37,10 @@
 	    PORT_WRITE(out_SPR_WRITE_ACK [j],registerfile_ack and status_ack);
 	  }
+      }
+    else
+      {
+	for (uint32_t j=0; j<_param->_nb_spr_write; j++)
+	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	    PORT_WRITE(out_SPR_WRITE_ACK [j], 0);
       }
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_write_status.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_write_status.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/Register_unit_Glue/src/Register_unit_Glue_genMealy_spr_write_status.cpp	(revision 123)
@@ -26,11 +26,5 @@
     log_function(Register_unit_Glue,FUNCTION,_name.c_str());
 
-//     if (not PORT_READ(in_NRESET))
-//       {
-// 	for (uint32_t j=0; j<_param->_nb_spr_write; j++)
-// 	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
-// 	    PORT_WRITE(out_SPR_WRITE_STATUS_VAL       [i][j], 0);
-//       }
-//     else
+    if (PORT_READ(in_NRESET))
       {
 	for (uint32_t j=0; j<_param->_nb_spr_write; j++)
@@ -48,4 +42,10 @@
 	  }
       }
+    else
+      {
+	for (uint32_t j=0; j<_param->_nb_spr_write; j++)
+	  for (uint32_t i=0; i<_param->_nb_ooo_engine; i++)
+	    PORT_WRITE(out_SPR_WRITE_STATUS_VAL       [i][j], 0);
+      }
 
     log_end(Register_unit_Glue,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Register_unit/src/Register_unit.cpp	(revision 123)
@@ -37,9 +37,9 @@
     log_printf(FUNC,Register_unit,FUNCTION,"Begin");
 
-#if DEBUG_Register_unit == true
-    log_printf(INFO,Register_unit,FUNCTION,_("<%s> Parameters"),_name.c_str());
+// #if DEBUG_Register_unit == true
+//     log_printf(INFO,Register_unit,FUNCTION,_("<%s> Parameters"),_name.c_str());
 
-    std::cout << *param << std::endl;
-#endif    
+//     std::cout << *param << std::endl;
+// #endif    
 
     log_printf(INFO,Register_unit,FUNCTION,"Allocation");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Execute_loop.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Execute_loop.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Execute_loop.cpp	(revision 123)
@@ -36,9 +36,9 @@
     log_printf(FUNC,Execute_loop,FUNCTION,"Begin");
 
-#if DEBUG_Execute_loop == true
-    log_printf(INFO,Execute_loop,FUNCTION,_("<%s> Parameters"),_name.c_str());
+// #if DEBUG_Execute_loop == true
+//     log_printf(INFO,Execute_loop,FUNCTION,_("<%s> Parameters"),_name.c_str());
 
-    std::cout << *param << std::endl;
-#endif    
+//     std::cout << *param << std::endl;
+// #endif    
 
     log_printf(INFO,Execute_loop,FUNCTION,"Allocation");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters_msg_error.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/src/Parameters_msg_error.cpp	(revision 123)
@@ -9,4 +9,5 @@
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/include/Parameters.h"
 #include <sstream>
+#include <set>
 
 namespace morpheo                    {
@@ -29,4 +30,26 @@
 	test.error(toString(_("Functionnal_unit [%d] must treat once instruction.\n"),i));
 
+    std::set<uint32_t> link_load_store_unit_and_write_unit [_nb_load_store_unit];
+    for (uint32_t i=0; i<_nb_load_store_unit; ++i)
+      link_load_store_unit_and_write_unit[i].clear();
+
+    for (uint32_t i=0; i<_nb_execute_unit; i++)
+      if (_is_load_store_unit [i])
+        {
+          uint32_t lsq = _translate_num_execute_unit[i];
+
+          for (uint32_t j=0; j<_nb_execute_unit_port[i]; j++)
+            for (uint32_t k=0; k<_nb_write_unit; k++)
+              if (_execution_unit_to_write_unit_table_routing [i][j][k])
+                {
+                  if (link_load_store_unit_and_write_unit[lsq].find(k) != link_load_store_unit_and_write_unit[lsq].end())
+                    {
+                      if (link_load_store_unit_and_write_unit[lsq].size() != 0)
+                        test.error(toString(_("Can't connect Load Store Unit [%d] (port %d) with Write unit [%d], because it's already connected with Write unit [%d]"),lsq,j,k,*(link_load_store_unit_and_write_unit[lsq].begin())));
+
+                      link_load_store_unit_and_write_unit[lsq].insert(link_load_store_unit_and_write_unit[lsq].end(),k);
+                    }
+                }
+        }
     log_printf(FUNC,Execute_loop,FUNCTION,"End");
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/include/Context_State.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/include/Context_State.h	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/include/Context_State.h	(revision 123)
@@ -143,4 +143,5 @@
     // ~~~~~[ Interface : "context" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   public    : SC_OUT(Tcontrol_t         )  ** out_CONTEXT_DECOD_ENABLE               ;//[nb_context]
+  public    : SC_OUT(Tcontrol_t         )  ** out_CONTEXT_EVENT                      ;//[nb_context]
 
     // ~~~~~[ Interface : "depth" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -211,4 +212,5 @@
   public  : void        genMoore                  (void);
   public  : void        genMealy_decod_event      (void);
+  public  : void        genMealy_context_event    (void);
 #endif					       
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State.cpp	(revision 123)
@@ -39,9 +39,9 @@
     usage_environment(_usage);
 
-#if DEBUG_Context_State == true
-    log_printf(INFO,Context_State,FUNCTION,_("<%s> Parameters"),_name.c_str());
+// #if DEBUG_Context_State == true
+//     log_printf(INFO,Context_State,FUNCTION,_("<%s> Parameters"),_name.c_str());
 
-    std::cout << *param << std::endl;
-#endif    
+//     std::cout << *param << std::endl;
+// #endif    
 
     log_printf(INFO,Context_State,FUNCTION,_("Allocation"));
@@ -139,4 +139,24 @@
 	// List dependency information
 # endif    
+
+	log_printf(INFO,Context_State,FUNCTION,_("Method - genMealy_context_event"));
+
+	SC_METHOD (genMealy_context_event);
+	dont_initialize ();
+// 	sensitive << (*(in_CLOCK)).neg(); // use internal register
+        sensitive << (*(in_COMMIT_EVENT_VAL             ));
+        if (_param->_have_port_context_id)				        
+        sensitive << (*(in_COMMIT_EVENT_CONTEXT_ID      ));
+        for (uint32_t i=0; i<_param->_nb_inst_branch_complete; ++i)
+          {
+            sensitive << (*(in_BRANCH_COMPLETE_VAL             [i]))
+                      << (*(in_BRANCH_COMPLETE_MISS_PREDICTION [i]));
+            if (_param->_have_port_context_id)				        
+            sensitive << (*(in_BRANCH_COMPLETE_CONTEXT_ID      [i]));
+          }
+	
+# ifdef SYSTEMCASS_SPECIFIC
+	// List dependency information
+# endif    
 	
 #endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_allocation.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_allocation.cpp	(revision 123)
@@ -172,4 +172,5 @@
       
       ALLOC1_SIGNAL_OUT(out_CONTEXT_DECOD_ENABLE               ,"decod_enable",Tcontrol_t,1);
+      ALLOC1_SIGNAL_OUT(out_CONTEXT_EVENT                      ,"event"       ,Tcontrol_t,1);
 
       ALLOC1_INTERFACE_END(_param->_nb_context);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_deallocation.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_deallocation.cpp	(revision 123)
@@ -91,4 +91,5 @@
         
 	DELETE1_SIGNAL(out_CONTEXT_DECOD_ENABLE               ,_param->_nb_context,1);
+	DELETE1_SIGNAL(out_CONTEXT_EVENT                      ,_param->_nb_context,1);
 
 	DELETE1_SIGNAL( in_DEPTH_MIN                          ,_param->_nb_context,_param->_size_depth);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_genMealy_context_event.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_genMealy_context_event.cpp	(revision 123)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_genMealy_context_event.cpp	(revision 123)
@@ -0,0 +1,72 @@
+#ifdef SYSTEMC
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Context_State/include/Context_State.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace core {
+namespace multi_front_end {
+namespace front_end {
+namespace context_state {
+
+
+#undef  FUNCTION
+#define FUNCTION "Context_State::genMealy_context_event"
+  void Context_State::genMealy_context_event (void)
+  {
+    log_begin(Context_State,FUNCTION);
+    log_function(Context_State,FUNCTION,_name.c_str());
+
+    bool context_event [_param->_nb_context];
+
+    // init
+    for (uint32_t i=0; i<_param->_nb_context; ++i)
+      context_event [i] = false;
+
+    if (PORT_READ(in_NRESET))
+      {
+    // Commit Event ?
+    if (PORT_READ(in_COMMIT_EVENT_VAL))
+      {
+        Tcontext_t context = (_param->_have_port_context_id)?PORT_READ(in_COMMIT_EVENT_CONTEXT_ID):0;
+      
+        context_event [context] = true;
+      }
+
+    // Miss ?
+    for (uint32_t i=0; i<_param->_nb_inst_branch_complete; ++i)
+    if (PORT_READ(in_BRANCH_COMPLETE_VAL             [i]) and
+        PORT_READ(in_BRANCH_COMPLETE_MISS_PREDICTION [i]))
+      {
+        Tcontext_t context = (_param->_have_port_context_id)?PORT_READ(in_BRANCH_COMPLETE_CONTEXT_ID [i]):0;
+      
+        context_event [context] = true;
+      }
+
+    for (uint32_t i=0; i<_param->_nb_context; ++i)
+      PORT_WRITE(out_CONTEXT_EVENT [i], context_event [i]);
+      }
+//     else
+//       {
+//       }
+
+    for (uint32_t i=0; i<_param->_nb_context; ++i)
+      PORT_WRITE(out_CONTEXT_EVENT [i], context_event [i]);
+
+    log_end(Context_State,FUNCTION);
+  };
+
+}; // end namespace context_state
+}; // end namespace front_end
+}; // end namespace multi_front_end
+}; // end namespace core
+
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_genMealy_decod_event.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_genMealy_decod_event.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_genMealy_decod_event.cpp	(revision 123)
@@ -24,4 +24,6 @@
     log_function(Context_State,FUNCTION,_name.c_str());
 
+    if (PORT_READ(in_NRESET))
+      {
     for (uint32_t i=0; i<_param->_nb_decod_unit; i++)
       {
@@ -49,6 +51,14 @@
 
         internal_DECOD_EVENT_ACK [i] = ack;
-        PORT_WRITE(out_DECOD_EVENT_ACK [i], internal_DECOD_EVENT_ACK [i]);
       }
+      }
+    else
+      {
+        for (uint32_t i=0; i<_param->_nb_decod_unit; i++)
+          internal_DECOD_EVENT_ACK [i] = 0;
+      }
+
+    for (uint32_t i=0; i<_param->_nb_decod_unit; i++)
+      PORT_WRITE(out_DECOD_EVENT_ACK [i], internal_DECOD_EVENT_ACK [i]);
 
     log_end(Context_State,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_genMoore.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_genMoore.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_genMoore.cpp	(revision 123)
@@ -24,4 +24,6 @@
     log_function(Context_State,FUNCTION,_name.c_str());
 
+    if (PORT_READ(in_NRESET))
+      {
     // -------------------------------------------------------------------
     // -----[ EVENT ]-----------------------------------------------------
@@ -67,5 +69,4 @@
 
         internal_EVENT_VAL [i] = val;
-	PORT_WRITE(out_EVENT_VAL              [i], val);
 	PORT_WRITE(out_EVENT_ADDRESS          [i], address);
 	PORT_WRITE(out_EVENT_ADDRESS_NEXT     [i], address_next); 
@@ -97,5 +98,4 @@
 	internal_SPR_EVENT_VAL [i] = (state == CONTEXT_STATE_KO_EXCEP_SPR  );
 
-	PORT_WRITE(out_SPR_EVENT_VAL       [i], internal_SPR_EVENT_VAL     [i]);
 	PORT_WRITE(out_SPR_EVENT_EPCR      [i], reg_EVENT_ADDRESS_EPCR     [i]);
 	PORT_WRITE(out_SPR_EVENT_EEAR      [i], reg_EVENT_ADDRESS_EEAR     [i]);
@@ -117,4 +117,22 @@
 	PORT_WRITE(out_CONTEXT_DECOD_ENABLE [i], (state==CONTEXT_STATE_OK));
       }
+      }
+    else
+      {
+        for (uint32_t i=0; i<_param->_nb_context; i++)
+          {
+            internal_EVENT_VAL     [i] = 0;
+            internal_SPR_EVENT_VAL [i] = 0;
+
+            PORT_WRITE(out_CONTEXT_DECOD_ENABLE [i], 0);
+          }
+      }
+
+    // Write output
+    for (uint32_t i=0; i<_param->_nb_context; i++)
+      {
+        PORT_WRITE(out_EVENT_VAL     [i], internal_EVENT_VAL     [i]);
+        PORT_WRITE(out_SPR_EVENT_VAL [i], internal_SPR_EVENT_VAL [i]);
+      }
 
     log_end(Context_State,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_transition.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/src/Context_State_transition.cpp	(revision 123)
@@ -16,10 +16,12 @@
 namespace context_state {
 
-#define MISS_FAST
+// #define MANAGE_EVENT MANAGE_EVENT_WAIT_ALL
+// #define MANAGE_EVENT MANAGE_EVENT_WAIT_DECODE
+#define MANAGE_EVENT MANAGE_EVENT_NO_WAIT
 
 #define get_priority(x) \
   (((state == CONTEXT_STATE_KO_MISS_LOAD_ADDR                  ) or  \
+    (state == CONTEXT_STATE_KO_MISS_LOAD_WAITEND               ) or  \
     (state == CONTEXT_STATE_KO_MISS_LOAD_AND_BRANCH_ADDR       ) or  \
-    (state == CONTEXT_STATE_KO_MISS_LOAD_WAITEND               ) or  \
     (state == CONTEXT_STATE_KO_MISS_LOAD_AND_BRANCH_WAITEND    ) or  \
     (state == CONTEXT_STATE_KO_MISS_LOAD_AND_BRANCH_WAIT_UPDATE))?3: \
@@ -43,4 +45,5 @@
             reg_STATE            [i] = CONTEXT_STATE_OK;
             reg_INTERRUPT_ENABLE [i] = 0;
+            reg_EVENT_DEPTH      [i] = 0; // unacessary
           }
       }
@@ -59,4 +62,7 @@
             Tcounter_t inst_all        = inst_commit_all + inst_decod_all;
 //          Tcounter_t inst_mem        = inst_commit_mem + inst_decod_all;
+            bool       condition       = ( (MANAGE_EVENT == MANAGE_EVENT_WAIT_ALL   )?(inst_all       == 0):
+                                          ((MANAGE_EVENT == MANAGE_EVENT_WAIT_DECODE)?(inst_decod_all == 0):
+                                            true));
 
             context_state_t state = reg_STATE [i];
@@ -89,14 +95,5 @@
               case CONTEXT_STATE_KO_MISS_BRANCH_WAITEND :
                 {
-                  // Wait end of all instruction
-//                if (inst_all == 0)
-                  if (
-#ifdef  MISS_FAST
-                      inst_decod_all ==
-#else
-                      inst_all ==
-#endif
-                      0)
-                    
+                  if (condition)
 //                  state = CONTEXT_STATE_OK;
                     state = CONTEXT_STATE_KO_MISS_BRANCH_ADDR;
@@ -106,12 +103,5 @@
                 {
                   // Wait end of all instruction
-//                if (inst_all == 0)
-                  if (
-#ifdef  MISS_FAST
-                      inst_decod_all ==
-#else
-                      inst_all ==
-#endif
-                      0)
+                  if (condition)
                     state = CONTEXT_STATE_KO_MISS_LOAD_ADDR;
 
@@ -146,12 +136,5 @@
                 {
                   // Wait end of all instruction
-//                if (inst_all == 0)
-                  if (
-#ifdef  MISS_FAST
-                      inst_decod_all ==
-#else
-                      inst_all ==
-#endif
-                      0)
+                  if (condition)
 //                  state = CONTEXT_STATE_OK; // @@@ TODO : make MISS fast (miss decod)
                     state = CONTEXT_STATE_KO_MISS_LOAD_AND_BRANCH_ADDR;
@@ -333,4 +316,5 @@
 #endif
 
+              log_printf(TRACE,Context_State,FUNCTION,"    * state     : %s",toString(state).c_str());
               log_printf(TRACE,Context_State,FUNCTION,"    * depth     : %d",depth     );
               log_printf(TRACE,Context_State,FUNCTION,"    * depth_cur : %d",depth_cur );
@@ -648,4 +632,7 @@
                           }
                         }
+
+                      depth = (depth+1)%_param->_nb_inst_branch_speculated[context];
+
                       break;
                     }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod.cpp	(revision 123)
@@ -38,9 +38,9 @@
     log_printf(FUNC,Decod,FUNCTION,"Begin");
 
-#if DEBUG_Decod == true
-    log_printf(INFO,Decod,FUNCTION,_("<%s> Parameters"),_name.c_str());
-
-    std::cout << *param << std::endl;
-#endif    
+// #if DEBUG_Decod == true
+//     log_printf(INFO,Decod,FUNCTION,_("<%s> Parameters"),_name.c_str());
+
+//     std::cout << *param << std::endl;
+// #endif    
 
     log_printf(INFO,Decod,FUNCTION,"Allocation");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_genMealy.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_genMealy.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod/src/Decod_genMealy.cpp	(revision 123)
@@ -25,4 +25,6 @@
     log_function(Decod,FUNCTION,_name.c_str());
 
+    if (PORT_READ(in_NRESET))
+      {
     //-----------------------------------
     // Initialization
@@ -280,4 +282,28 @@
 #endif
       }
+      }
+    else
+      {
+    for (uint32_t i=0; i<_param->_nb_context; i++)
+      {
+	internal_CONTEXT_HAVE_TRANSACTION [i] = false;
+// 	internal_CONTEXT_ADDRESS_PREVIOUS [i] = reg_CONTEXT_ADDRESS_PREVIOUS [i];
+// 	internal_CONTEXT_IS_DELAY_SLOT    [i] = reg_CONTEXT_IS_DELAY_SLOT    [i];
+      for (uint32_t j=0; j<_param->_nb_inst_fetch[i]; j++)
+	PORT_WRITE(out_IFETCH_ACK [i][j], 0);
+      }
+
+    PORT_WRITE(out_CONTEXT_EVENT_VAL, 0);
+
+    for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+      {
+	PORT_WRITE(out_PREDICT_VAL [i], 0);
+	PORT_WRITE(out_DECOD_VAL   [i], 0);
+
+#ifdef STATISTICS
+        internal_DECOD_VAL [i] = 0;
+#endif
+      }
+      }
 
     log_end(Decod,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Decod_queue.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Decod_queue.h	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/include/Decod_queue.h	(revision 123)
@@ -106,4 +106,6 @@
   public    : SC_OUT(Toperation_t       )  ** out_DECOD_OUT_OPERATION     ;//[nb_inst_decod]
   public    : SC_OUT(Tcontrol_t         )  ** out_DECOD_OUT_NO_EXECUTE    ;//[nb_inst_decod]
+//public    : SC_OUT(Tcontrol_t         )  ** out_DECOD_OUT_HAVE_EVENT    ;//[nb_inst_decod]
+  public    : SC_OUT(Tcontrol_t         )  ** out_DECOD_OUT_LAST_EVENT    ;//[nb_inst_decod]
   public    : SC_OUT(Tcontrol_t         )  ** out_DECOD_OUT_IS_DELAY_SLOT ;//[nb_inst_decod]
 #ifdef DEBUG
@@ -134,4 +136,7 @@
   public    : SC_OUT(Tcounter_t         )  ** out_NB_INST_ALL             ;//[nb_context]
 
+    // ~~~~~[ Interface : "context" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_IN (Tcontrol_t         )  **  in_CONTEXT_EVENT           ;//[nb_context]
+
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
@@ -141,4 +146,6 @@
   private   : std::list<decod_queue_entry_t*> * reg_QUEUE                  ;
   private   : uint32_t                        * reg_NB_INST                ;//[nb_context]
+  private   : uint32_t                        * reg_NB_INST_EVENT          ;//[nb_context]
+
     // implementation : one_fifo only
   private   : uint32_t                          reg_LAST_SLOT              ;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue.cpp	(revision 123)
@@ -40,9 +40,9 @@
     usage_environment(_usage);
 
-#if DEBUG_Decod_queue == true
-    log_printf(INFO,Decod_queue,FUNCTION,_("<%s> Parameters"),_name.c_str());
+// #if DEBUG_Decod_queue == true
+//     log_printf(INFO,Decod_queue,FUNCTION,_("<%s> Parameters"),_name.c_str());
 
-    std::cout << *param << std::endl;
-#endif    
+//     std::cout << *param << std::endl;
+// #endif    
 
     log_printf(INFO,Decod_queue,FUNCTION,_("Allocation"));
@@ -129,28 +129,28 @@
 	for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
 	  sensitive << (*(in_DECOD_OUT_ACK [i]));
-	  for (uint32_t i=0; i<_param->_nb_context; i++)
-            {
-              if (_param->_have_port_depth)
-                {
-              sensitive << (*(in_DEPTH_MIN [i]));
-              sensitive << (*(in_DEPTH_MAX [i]));
-                }
-              sensitive << (*(in_DEPTH_FULL[i]));
-            }
+//         for (uint32_t i=0; i<_param->_nb_context; i++)
+//           {
+//             if (_param->_have_port_depth)
+//               {
+//                 sensitive << (*(in_DEPTH_MIN [i]));
+//                 sensitive << (*(in_DEPTH_MAX [i]));
+//               }
+//             sensitive << (*(in_DEPTH_FULL[i]));
+//           }
 
 # ifdef SYSTEMCASS_SPECIFIC
-	// List dependency information
-	for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
-	  {
-	    (*(out_DECOD_OUT_VAL [i])) (*(in_DECOD_OUT_ACK [i]));
-            for (uint32_t j=0; j<_param->_nb_context; j++)
-              {
-                if (_param->_have_port_depth)
-                  {
-                (*(out_DECOD_OUT_VAL [i])) (*(in_DEPTH_MIN [j]));
-                (*(out_DECOD_OUT_VAL [i])) (*(in_DEPTH_MAX [j]));
-                  }
-              }
-	  }
+// 	// List dependency information
+// 	for (uint32_t i=0; i<_param->_nb_inst_decod; i++)
+// 	  {
+// 	    (*(out_DECOD_OUT_VAL [i])) (*(in_DECOD_OUT_ACK [i]));
+//             for (uint32_t j=0; j<_param->_nb_context; j++)
+//               {
+//                 if (_param->_have_port_depth)
+//                   {
+//                 (*(out_DECOD_OUT_VAL [i])) (*(in_DEPTH_MIN [j]));
+//                 (*(out_DECOD_OUT_VAL [i])) (*(in_DEPTH_MAX [j]));
+//                   }
+//               }
+// 	  }
 # endif    
 	
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_allocation.cpp	(revision 122)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Decod_unit/Decod_queue/src/Decod_queue_allocation.cpp	(revision 123)
@@ -100,4 +100,6 @@
       ALLOC1_SIGNAL_OUT(out_DECOD_OUT_OPERATION      ,"operation"    ,Toperation_t       ,_param->_size_operation             );
       ALLOC1_SIGNAL_OUT(out_DECOD_OUT_NO_EXECUTE     ,"no_execute"   ,Tcontrol_t         ,1                                   );
+//    ALLOC1_SIGNAL_OUT(out_DECOD_OUT_HAVE_EVENT     ,"have_event"   ,Tcontrol_t         ,1                                   );
+      ALLOC1_SIGNAL_OUT(out_DECOD_OUT_LAST_EVENT     ,"last_event"   ,Tcontrol_t         ,1                                   );
       ALLOC1_SIGNAL_OUT(out_DECOD_OUT_IS_DELAY_SLOT  ,"is_delay_slot",Tcontrol_t         ,1                                   );
 #ifdef DEBUG
@@ -143,4 +145,13 @@
     }
 
+    // ~~~~~[ Interface : "context" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~            
+    {
+      ALLOC1_INTERFACE_BEGIN("context",IN ,NORTH,_("Context"), _param->_nb_context);
+
+      ALLOC1_SIGNAL_IN ( in_CONTEXT_EVENT  ,"event"    ,Tcontrol_t         ,1);
+
+      ALLOC1_INTERFACE_END(_param->_nb_context);
+    }
+
     if (usage_is_set(_usage,USE_SYSTEMC))
       {
@@ -152,5 +163,6 @@
       }
 
-    ALLOC1(reg_NB_INST,uint32_t,_param->_nb_context);
+    ALLOC1(reg_NB_INST           ,uint32_t,_param->_nb_context);
+    ALLOC1(reg_NB_INST_EVENT     ,uint32_t,_param->_nb_context);
 
     // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
